'use strict';

/* global module */
module.exports = {
  'env': {
    'es2020': true,
    'browser': true,
    'webextensions': true,
    'jest': true,
  },
  'extends': 'eslint:recommended',
  'globals': {
    'Atomics': 'readonly',
    'SharedArrayBuffer': 'readonly',
  },
  'rules': {
    'no-unused-vars': 1,
    'comma-spacing': 2,
    'comma-dangle': [1, 'always-multiline'],
    'strict': [2, 'global'],
    'eqeqeq': 2,
    'no-eval': 2,
    'no-implied-eval': 2,
    'no-implicit-coercion': 2,
    'no-floating-decimal': 2,
    'no-else-return': 2,
    'no-alert': 2,
    'guard-for-in': 2,
    'dot-notation': 2,
    'curly': 2,
    'consistent-return': 2,
    'no-template-curly-in-string': 1,
    'no-extra-parens': 2,
    'no-await-in-loop': 1,
    'require-await': 1,
    'no-useless-return': 2,
    'no-unused-expressions': 1,
    'no-new': 2,
    'no-multi-spaces': 2,
    // 'no-magic-numbers': [1, {
    //   'ignore': [-1, 0, 1, 2],
    //   'enforceConst': true,
    // }],
    'arrow-parens': 2,
    'no-undefined': 2,
    'no-use-before-define': 2,
    'eol-last': 2,
    'no-lone-blocks': 2,
    'no-shadow': 2,
    'array-bracket-spacing': 2,
    'block-spacing': 2,
    'computed-property-spacing': 2,
    'brace-style': 2,
    'camelcase': 1,
    'array-element-newline': [2, 'consistent'],
    'array-bracket-newline': [2, 'consistent'],
    'object-property-newline': [2, { 'allowAllPropertiesOnSameLine': true }],
    'object-curly-newline': 2,
    'object-curly-spacing': [2, 'always'],
    'indent': [1, 2, { 'SwitchCase': 1 }],
    'linebreak-style': 2,
    'implicit-arrow-linebreak': 2,
    'max-len': [1, {
      'code': 100,
      'ignoreUrls': true,
    }],
    'max-statements-per-line': 2,
    'new-cap': 2,
    'prefer-const': 2,
    'no-var': 2,
    'prefer-arrow-callback': 2,
    'spaced-comment': [2, 'always', {
      'block': { 'balanced': true },
    }],
    'space-infix-ops': 2,
    'space-unary-ops': 2,
    'space-in-parens': 2,
    'space-before-function-paren': [2, {
      'anonymous': 'always',
      'named': 'never',
      'asyncArrow': 'always',
    }],
    'quotes': [2, 'single', { 'avoidEscape': true }],
    'semi': 2,
    'semi-spacing': 2,
    'semi-style': 2,
    'space-before-blocks': 2,
    'no-multiple-empty-lines': [1, { 'max': 1, 'maxEOF': 0 }],
    'no-trailing-spaces': 2,
    'no-tabs': 2,
    'no-whitespace-before-property': 2,
    'operator-linebreak': [2, 'before'],
    'prefer-exponentiation-operator': 2,
    'no-duplicate-imports': 2,
    'function-paren-newline': 2,
    'prefer-promise-reject-errors': 1,
    'no-promise-executor-return': 2,
  },
};
